/*
 * $Id: CharsetUtilsTest.java,v 1.2 2006/02/21 12:58:50 akabane Exp $
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 *
 */
package org.logical_paradox.common.charset;

import junit.framework.TestCase;


/**
 * LZbg[eBeB̃eXg
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class CharsetUtilsTest extends TestCase {
	public static final String ENCODING = "UTF-16BE";

	/**
	 * GR[fBOϊ̃eXg
	 * @throws Exception ȂO
	 */
	public void testEncoding() throws Exception {
		String msg = "ɂ́CԉHłD|\Efr[߂??";

		String encodedString = CharsetUtils.encode(ENCODING, msg);
		String decodedString = CharsetUtils.decode(ENCODING, encodedString);

		assertEquals(msg, decodedString);
	}
	/**
	 * GR[fBOϊKvǂ̃eXg̃eXg(GR[fBO)
	 * VXeGR[fBOnāCfalseԋp̂mFD
	 */
	public void testTestNeedToEncodeSame() {
		String systemEncoding = System.getProperty("file.encoding");
		assertFalse(CharsetUtils.testNeedToEncode(systemEncoding));
	}
	/**
	 * GR[fBOϊKvǂ̃eXg̃eXg(GR[fBO)
	 * VXeGR[fBOƓ̂̃GR[fBOw肵falseԋp̂mFD
	 */
	public void testTestNeedToEncodeNear() {
		String systemEncoding = "Windows-31J";
		assertFalse(CharsetUtils.testNeedToEncode(systemEncoding));
	}
	/**
	 * GR[fBOϊKvǂ̃eXg̃eXg(GR[fBO)
	 * VXeGR[fBOƈႤ̂̃GR[fBOw肵trueԋp̂mFD
	 */
	public void testTestNeedToEncodingDifferent() {
		assertTrue(CharsetUtils.testNeedToEncode("euc-jp"));
	}
}
